<?php
//log them out
$logout = $_GET['logout'];
if ($logout == "yes") { //destroy the session
	session_start();
	$_SESSION = array();
	$cookie_crypt = mcrypt_encrypt(MCRYPT_RIJNDAEL_256, session_id(), $username.",".(time() - 3600).",".session_id(), MCRYPT_MODE_ECB);
        $cookie_value = bin2hex($cookie_crypt);
        setcookie (session_id(), $cookie_value, time() - 3600, "", "", 1);
	session_destroy();
	header('Location: ./');
}


//you should look into using PECL filter or some form of filtering here for POST variables
$ini_array = parse_ini_file("config.ini");
$config_accountSuffix = $ini_array['accountSuffix'];
$config_baseDn = $ini_array['baseDn'];
$config_domainControllers = $ini_array['domainControllers'];

$host = $ini_array['host'];
$user = $ini_array['user'];
$pass = $ini_array['pass'];

$username = strtoupper($_POST["username"]); //remove case sensitivity on the username
$password = $_POST["password"];
$formage = $_POST["formage"];

if ($_POST["oldform"]) { //prevent null bind

	if ($username != NULL && $password != NULL){
		//include the class and create a connection
		include (dirname(__FILE__) . "/adLDAP/src/adLDAP.php");
        try {
		$adldap = new adLDAP(array('base_dn'=>$config_baseDn, 'account_suffix'=>$config_accountSuffix, 'domain_controllers'=>array($config_domainControllers)));
        }
        catch (adLDAPException $e) {
            echo $e; 
            exit();   
        }
		
		//authenticate the user
		if ($adldap->authenticate($username, $password)){
			//establish your session and redirect
			session_start();
			$_SESSION['sess_id'] = session_id();
			$_SESSION["username"] = $username;
		        $_SESSION["userinfo"] = $adldap->user()->info($username);
			$_SESSION['group_arr'] = $adldap->user()->info($username, array('memberof'));
			$cookie_crypt = mcrypt_encrypt(MCRYPT_RIJNDAEL_256, session_id(), $username.",".time().",".session_id(), MCRYPT_MODE_ECB);
			$cookie_value = bin2hex($cookie_crypt);
			setcookie (session_id(), $cookie_value, time()+3600, "", "", 1);
			header('Location: main.php');
			exit;
		}
	}
	$failed = 1;
}

?>

<!DOCTYPE html>
<html>
<head>
<title>Active Directory Audit</title>
<meta name='author' content='Nicolas HAHANG' />
<meta name='copyright' content='2014 - Nicolas HAHANG' />
<meta charset="UTF-8">
<link href="css/bootstrap.min.css" rel="stylesheet">
<link href="css/grid.css" rel="stylesheet">
</head>
<body data-spy="scroll" data-target="#my-nav">
	<nav class="navbar navbar-default navbar-fixed-top" role="navigation">
	  <!-- Brand and toggle get grouped for better mobile display -->
	  <div class="navbar-header">
		<div class="navbar-header navbar-left title"><h2>Active Directory Audit</h2></div>
	  </div>
	</nav>
	<div class="col-md-10 col-lg-10 main_login">
		<div class="col-md-4 col-lg-3 col-sm-5 col-xs-11">
		<label>Restricted Area - Please enter your credentials (Session limit duration : 1 hour)</label><br><br>
		<form role="form" method='post' action='<?php echo $_SERVER["PHP_SELF"]; ?>'>
		<input type='hidden' name='oldform' value='1'>
			<div class="form-group">
				<input type="username" class="form-control input-medium" name="username" id="username" placeholder="Username">
			</div>
			<div class="form-group">
				<input type="password" class="form-control input-medium" name="password" id="password" placeholder="Password">
			</div>
			<button type="submit" class="btn btn-primary">Submit</button>
			<?php if ($failed){ echo ("<br><br>Login Failed!<br><br>\n"); } ?>
		</form>
		</div>
	</div>
</body>
</html>
